%---------------- saves phase space to file -------------------------------
function [ data ] = psv_save( data )
    if nargin ~= 1; return ; end;
%
% is there a phase space to save?
if(isstruct(data.ps))
    if(length(data.ps) >= data.my_axes)
        if(isfield(data.ps(data.my_axes),'phasespace'))
            if(length(data.ps(data.my_axes).phasespace) >=1)
                if(length(data.ps(data.my_axes).phasespace) >=100)
                else
                    uiwait(msgbox('Less than 100 particles to save!','psv_save warning','warning'))
                end
            else
                uiwait(msgbox('Less than 100 particles to save!','psv_save error','error'))
                return
            end
        else
            uiwait(msgbox('No phase space data (field phasespace not in structure ps)!','psv_save error','error'))
            return
        end
    else
        uiwait(msgbox('No phase space data (structure ps not filled for this axes)!','psv_save error','error'))
        return
    end
else
    uiwait(msgbox('No phase space data (structure ps does not exist)!','psv_save error','error'))
end
%        
% read default path structure and set default path
default_path = pwd;

if(isstruct(data.psv_defaults))
    if(length(data.psv_defaults) == 3)
        if(isfield(data.psv_defaults(3),'path'))
            if(exist(char(data.psv_defaults(3).path)) == 7)
                default_path = char(data.psv_defaults(3).path);
            end
        end
    end   
end
%
% because it is not possible to specify a search path for UIPUTFILE, use CD
this_dir = pwd;
cd(default_path);
%
[filename, pathname, filterindex] = uiputfile( ...
    {'*.*' , 'Choose File Type';
    '*.fmt1', 'CSRtrack Format 1 (*.fmt1)'; ...
         '*.ele', 'elegant Format (*.ele)'; ...
          '*.ini', 'ASTRA Format (*.ini)'; ...
    }, ...
    'Save Phase Space as');
%
cd(this_dir);
%
if(filename == 0)
    return
else
    data.psv_defaults(3).path = {pathname};
    save ps_viewer_data default_path
end
    if filterindex == 1
        psv_message(data, 'ERROR: Select file type!',0);
        psv_message(data, 'ERROR: Select file type!',1);
        return;
    end
% write file
[dummy dummy ext dummy] = fileparts(filename);
data.ps(data.my_axes).ft = ext(2:length(ext));
file_name = [pathname filename];
data = psv_write_file( data, file_name );
